/*
 * DataTypes.h
 *
 *  Created on: Jan 17, 2010
 *      Author: duyvu
 */

#ifndef DATATYPES_H_
#define DATATYPES_H_

using namespace std;

#include <list>
#include <vector>
#include <set>
#include <map>

#include <iostream>
#include <fstream>

#define SIGNED_GRAPH 1

#define NR_MM_EXCESS_TRUST_GRAPH 1
#define BOOTSTRAP_NR_MM_EXCESS_TRUST_GRAPH 2

#define SPARSE_FORMAT 0
#define MATRIX_FORMAT 1

#define BLANK_SPACE 0
#define TAB 1

#define MIN_TAU 1e-10
#define MIN_ALPHA 1e-10
#define MIN_PI 1e-10

#define TAU_PRECISION 1e-10
#define PI_PRECISION 1e-10

#define REL_LLH 1e-10

#define HARD_PERCENTAGE .5

using namespace std;

namespace mixderg {

typedef vector<unsigned int> UnsignedIntVector;

typedef vector<int> IntVector;

typedef vector<long> LongVector;

typedef vector<double> DoubleVector;

typedef vector<vector<double> > DoubleMatrix;

typedef vector<DoubleMatrix> VectorOfDoubleMatrices;

typedef vector<vector<DoubleVector> > MatrixOfDoubleVectors;

typedef set<unsigned int> NodeSet;

typedef vector<NodeSet> VectorOfNodeSet;

typedef vector<double*> DoublePointerVector;

typedef vector<vector<double*> > DoublePointerMatrix;

typedef vector<NodeSet> EdgeSet;

typedef struct {
	unsigned int sender;
	unsigned int receiver;
	int value;
} Edge;

typedef list<Edge> EdgeList;

inline void printDoubleVector2TextFile(const DoubleVector& vector,
		const char* filename, unsigned int outputPrecision) {
	ofstream outputFile;
	outputFile.open(filename);
	if (outputFile.is_open()) {
		outputFile.precision(outputPrecision);
		for (unsigned int k = 0; k < vector.size() - 1; k++)
			outputFile << vector[k] << "\t";
		outputFile << vector[vector.size() - 1];
		outputFile.close();
	} else
		cout << "Can not open the file " << filename << endl;
}

inline void printDoubleVector2TextFile(const DoubleVector& vector,
		ofstream& outputFile) {
	for (unsigned int k = 0; k < vector.size() - 1; k++)
		outputFile << vector[k] << "\t";
	outputFile << vector[vector.size() - 1];
}

inline void printDoubleVector(const char* message, const DoubleVector& vector) {
	cout << message << endl;
	for (unsigned int k = 0; k < vector.size(); k++)
		cout << vector[k] << "\t";
	cout << endl;
}

inline void printDoubleMatrix(const char* message, const DoubleMatrix& matrix) {
	cout << message << endl;
	for (unsigned int i = 0; i < matrix.size(); i++) {
		for (unsigned int j = 0; j < matrix[0].size(); j++)
			cout << matrix[i][j] << "\t";
		cout << endl;
	}
}

}

#endif /* DATATYPES_H_ */
